import speech_recognition as sr
from espeakng import ESpeakNG
from num2words import num2words
from time import sleep
import os, datetime, random
import RPi.GPIO as GPIO
import Adafruit_DHT as DHT

r=sr.Recognizer()
m=sr.Microphone()

esng=ESpeakNG(voice='en')
esng.pitch = 10
esng.speed = 150
esng.say("Hello, what's up?", sync=True)

LEDPin=14
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)
GPIO.setup(LEDPin,GPIO.OUT)

phrase1 = "Good morning Dr Falken"
phrase2 = "The CPU temperature is "
phrase3 = "degrees Centigrade"

sensorType=11   # for DHT11
humiturePin=4

def getCPUtemperature():
    res = os.popen('vcgencmd measure_temp').readline()
    return(res.replace("temp=","").replace("'C\n",""))

#database
greetings=['hello', 'hi', 'hey']
questions=['how are you', 'how are you doing']
responses=['okay', 'i am fine']
database={
    'hello Robert':'hello, dr Falken, how can i help you',
    'name':'Robert',
    'what is your name':'my name is Robert',
    'what can you do for me':'i can do many things..',
    'I love you':'i love you too'
        }
exitWord=['quit','exit','bye','goodbye']

#chatbot code here
def chatbot(data):
    if data in database:
        print(database[data])
        esng.say(database[data], sync=True)
        
    elif data in questions:
        random_response = random.choice(responses)
        print(random_response)
        esng.say(random_response, sync=True)
     
    elif data in greetings:
        random_greeting=random.choice(greetings)
        print(random_greeting)
        esng.say(random_greeting,sync=True)
        
    elif 'light on'in data in data:
        print("turning light on")
        esng.say("turning light on", sync=True)
        GPIO.output(LEDPin,True)
   
    elif 'light of' in data in data:
        print("turning light off")
        esng.say("turning light off", sync=True)
        GPIO.output(LEDPin,False)
   
    elif 'time' in data:
        now = datetime.datetime.now()
        time=str(now.hour)+str("hours")+str(now.minute)+str("minutes")
        print(time)
        esng.say("it is ", sync=True)
        esng.say(str(now.hour)+str("hours")+"and"+str(now.minute)+str("minutes"), sync=True)
   
    elif 'date'in data:
        now = datetime.datetime.now()
        date=str("%s %s %s" % (now.day,now.month,now.year))
        print(date)
        esng.say(str("%s of %s in the year %s" % (now.day,now.month,now.year)), sync=True)
            
    elif 'CPU temperature' in data:
        print("You said: %s" % reply)
        tempCPU=getCPUtemperature()
        print("CPU temperature: ", tempCPU, end=""); print(" °C")
        number=num2words(tempCPU)
        esng.say("the CPU temperature is", sync=True)
        esng.say(number, sync=True)
        esng.say(phrase3, sync=True)
    
    elif 'temperature' in data:
        print("You said: %s" % reply)
        humidity, temperature = DHT.read_retry(sensorType, humiturePin)
        print("The room temperature is: ", temperature, end=""); print(" °C")
        number=num2words(temperature)
        esng.say("the room temperature is", sync=True)
        esng.say(number, sync=True)
        esng.say(phrase3, sync=True)
    
    elif 'humidity' in data:
        print("You said: %s" % reply)
        humidity, temperature = DHT.read_retry(sensorType, humiturePin)
        print("Humidity is around: ", humidity, end=""); print(" %")
        number=num2words(humidity)
        esng.say("Humidity is around", sync=True)
        esng.say(number, sync=True)
        esng.say("%", sync=True)
        
    elif 'duck' in data:
        print("You said: %s" % reply)
        esng.say("quack quack quack", sync=True)
      
    elif 'dog' in data:
        print("You said: %s" % reply)
        esng.say("wow wow wow", sync=True)
    
    elif 'cat' in data:
        print("You said: %s" % reply)
        esng.say("me au, me au", sync=True)
    
    else:
        print("sorry, didn't get it, please repeat...")
        esng.say("sorry, didn't get it,  please repeat", sync=True)          
try:
    with m as source: r.adjust_for_ambient_noise(source)
    while True:
        print("Now Ready, talk to me!")
        with m as source: audio = r.listen(source)
        print(".")
        try:
            value = r.recognize_google(audio)
            if str is bytes:
                reply = "{}".format(value).encode("utf-8")
                data=reply
                print("My reply: ", end="")
                chatbot(data)
            else:
                reply = "{}".format(value)
            if reply in exitWord:
                print("You said: %s" % reply)
                esng.say("Good bye dr Falken, it was good to talk to you")
                print("bye..")
                break
            else:
                print("You said: %s" % reply)
                data=reply
                print("My reply: ", end="")
                chatbot(data)
        except sr.UnknownValueError:
            print("Google API could not understand audio...")
        except sr.RequestError as e:
            print("Couldn't request results from Google; {0}".format(e))
except KeyboardInterrupt:
    pass
