#!/usr/bin/python3
# -*- coding: utf-8 -*-
# sudo apt install espeak-ng espeak-ng-data libespeak-ng-dev
# sudo pip3 install py-espeak-ng

from espeakng import ESpeakNG
from time import sleep
import Adafruit_DHT as DHT

esng=ESpeakNG(voice='de')
esng.pitch=25
esng.speed=140
sensorType=11   # for DHT11
humiturePin=4

while True:
    humidity, temperature = DHT.read_retry(sensorType, humiturePin)

    if humidity is not None and temperature is not None:
        print ('Temp = {0:0.1f} C  Humidity = {1:0.1f} %'.format(temperature, humidity))
    else:
        print ('Failed to get reading. Try again!')

    esng.say('Die Raumtemperatur beträgt', sync=True)
    esng.say(str(temperature), sync=True)
    esng.say('grad Celsius', sync=True)

    esng.say('Die Luftfeuchtigkeit liegt bei', sync=True)
    esng.say(str(humidity), sync=True)
    esng.say('prozent',sync=True)
    for i in range(0,3):
        print(".")
        sleep(1)
    print()